/*     */ package com.netapp.asup.data.objects;
/*     */ 
/*     */ import java.io.IOException;
/*     */ import java.util.ArrayList;
/*     */ import java.util.HashMap;
/*     */ import java.util.List;
/*     */ import java.util.Map;
/*     */ import java.util.Map.Entry;
/*     */ import java.util.Set;
/*     */ import org.apache.avro.generic.GenericRecord;
/*     */ import org.apache.avro.util.Utf8;
/*     */ 
/*     */ public class ObjectsRequest
/*     */   extends AvroObject<Map<Utf8, GenericRecord>>
/*     */ {
/*  16 */   private final Map<Utf8, ObjectRequest> objectDataMap = new HashMap();
/*     */   
/*     */   public ObjectsRequest(String id) {
/*  19 */     super(ARMASchema.OBJECT_REQUEST, id);
/*     */   }
/*     */   
/*     */   public ObjectsRequest(Map<Utf8, GenericRecord> object, String id) {
/*  23 */     super(ARMASchema.OBJECT_REQUEST, id);
/*  24 */     this.object = object;
/*     */   }
/*     */   
/*     */   public void addRequestObject(Utf8 objectName, ObjectRequest reqObject) {
/*  28 */     getObjectDataMap().put(objectName, reqObject);
/*     */   }
/*     */   
/*     */   public ObjectRequest getRequestObject(Utf8 objectName) {
/*  32 */     ObjectRequest objectData = (ObjectRequest)getObjectDataMap().get(objectName);
/*  33 */     if (objectData != null)
/*  34 */       return objectData;
/*  35 */     if (this.object != null) {
/*  36 */       objectData = new ObjectRequest((GenericRecord)((Map)this.object).get(objectName), this.id);
/*  37 */       getObjectDataMap().put(objectName, objectData);
/*  38 */       return objectData;
/*     */     }
/*  40 */     return null;
/*     */   }
/*     */   
/*     */ 
/*     */   public void removeRequestObject(Utf8 objectName)
/*     */   {
/*  46 */     if (getObjectDataMap().isEmpty()) {
/*  47 */       ((Map)this.object).remove(objectName);
/*     */     } else {
/*  49 */       getObjectDataMap().remove(objectName);
/*     */     }
/*     */   }
/*     */   
/*     */   public void updateRequestObjectAsCached(Utf8 objectName) {
/*  54 */     ObjectRequest requestObject = getRequestObject(objectName);
/*  55 */     if (null != requestObject) {
/*  56 */       requestObject.setObjectCached(Boolean.valueOf(true));
/*     */     }
/*     */   }
/*     */   
/*     */   public Utf8 getObjectByIndex(int index)
/*     */   {
/*  62 */     List<Utf8> objects = getObjects();
/*  63 */     if (objects.size() < index + 1) {
/*  64 */       throw new IllegalArgumentException("No request Object forund");
/*     */     }
/*  66 */     return (Utf8)objects.get(index);
/*     */   }
/*     */   
/*     */   public List<Utf8> getObjects()
/*     */   {
/*  71 */     Set<Utf8> keySet = getObjectDataMap().keySet();
/*  72 */     if ((keySet.isEmpty()) && (null != this.object)) {
/*  73 */       keySet = ((Map)this.object).keySet();
/*     */     }
/*  75 */     return new ArrayList(keySet);
/*     */   }
/*     */   
/*     */   public List<Utf8> getNonCachedObjects()
/*     */   {
/*  80 */     ArrayList<Utf8> nonCachedObjNames = new ArrayList();
/*  81 */     for (Utf8 key : getObjects()) {
/*  82 */       ObjectRequest requestObject = getRequestObject(key);
/*  83 */       if ((null != requestObject) && (!requestObject.isObjectCached().booleanValue())) {
/*  84 */         nonCachedObjNames.add(key);
/*     */       }
/*     */     }
/*  87 */     return nonCachedObjNames;
/*     */   }
/*     */   
/*     */ 
/*     */   public String getId()
/*     */   {
/*  93 */     return "objects";
/*     */   }
/*     */   
/*     */   public Map<Utf8, GenericRecord> getObject() throws IOException
/*     */   {
/*  98 */     Map<Utf8, GenericRecord> object = new HashMap();
/*  99 */     for (Map.Entry<Utf8, ObjectRequest> entry : getObjectDataMap().entrySet()) {
/* 100 */       object.put(entry.getKey(), ((ObjectRequest)entry.getValue()).getObject());
/*     */     }
/* 102 */     return object;
/*     */   }
/*     */   
/*     */   public boolean isOptionsAvailable()
/*     */   {
/* 107 */     List<Utf8> objectNames = getObjects();
/*     */     
/*     */ 
/* 110 */     for (Utf8 objectName : objectNames) {
/* 111 */       ObjectRequest requestObject = getRequestObject(objectName);
/* 112 */       if (requestObject.isOptionsAvailable()) {
/* 113 */         return true;
/*     */       }
/*     */     }
/* 116 */     return false;
/*     */   }
/*     */   
/*     */   public List<Utf8> getOptions()
/*     */   {
/* 121 */     List<Utf8> optionObjects = new ArrayList();
/* 122 */     List<Utf8> objectNames = getObjects();
/*     */     
/*     */ 
/* 125 */     for (Utf8 objectName : objectNames) {
/* 126 */       ObjectRequest requestObject = getRequestObject(objectName);
/* 127 */       if (requestObject.isOptionsAvailable()) {
/* 128 */         optionObjects.add(objectName);
/*     */       }
/*     */     }
/* 131 */     return optionObjects;
/*     */   }
/*     */   
/*     */   public Map<Utf8, ObjectRequest> getObjectDataMap() {
/* 135 */     return this.objectDataMap;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\data\objects\ObjectsRequest.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */