/*     */ package com.sun.xml.bind.v2.model.annotation;
/*     */ 
/*     */ import java.lang.annotation.Annotation;
/*     */ import java.lang.reflect.Field;
/*     */ import java.lang.reflect.InvocationTargetException;
/*     */ import java.lang.reflect.Method;
/*     */ import java.lang.reflect.Type;
/*     */ import java.util.HashMap;
/*     */ import java.util.Map;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public final class RuntimeInlineAnnotationReader
/*     */   extends AbstractInlineAnnotationReaderImpl<Type, Class, Field, Method>
/*     */   implements RuntimeAnnotationReader
/*     */ {
/*     */   public <A extends Annotation> A getFieldAnnotation(Class<A> annotation, Field field, Locatable srcPos)
/*     */   {
/*  21 */     return LocatableAnnotation.create(field.getAnnotation(annotation), srcPos);
/*     */   }
/*     */   
/*     */   public boolean hasFieldAnnotation(Class<? extends Annotation> annotationType, Field field) {
/*  25 */     return field.isAnnotationPresent(annotationType);
/*     */   }
/*     */   
/*     */   public Annotation[] getAllFieldAnnotations(Field field, Locatable srcPos) {
/*  29 */     Annotation[] r = field.getAnnotations();
/*  30 */     for (int i = 0; i < r.length; i++) {
/*  31 */       r[i] = LocatableAnnotation.create(r[i], srcPos);
/*     */     }
/*  33 */     return r;
/*     */   }
/*     */   
/*     */   public <A extends Annotation> A getMethodAnnotation(Class<A> annotation, Method method, Locatable srcPos) {
/*  37 */     return LocatableAnnotation.create(method.getAnnotation(annotation), srcPos);
/*     */   }
/*     */   
/*     */   public boolean hasMethodAnnotation(Class<? extends Annotation> annotation, Method method) {
/*  41 */     return method.isAnnotationPresent(annotation);
/*     */   }
/*     */   
/*     */   public Annotation[] getAllMethodAnnotations(Method method, Locatable srcPos) {
/*  45 */     Annotation[] r = method.getAnnotations();
/*  46 */     for (int i = 0; i < r.length; i++) {
/*  47 */       r[i] = LocatableAnnotation.create(r[i], srcPos);
/*     */     }
/*  49 */     return r;
/*     */   }
/*     */   
/*     */   public <A extends Annotation> A getMethodParameterAnnotation(Class<A> annotation, Method method, int paramIndex, Locatable srcPos) {
/*  53 */     Annotation[] pa = method.getParameterAnnotations()[paramIndex];
/*  54 */     for (Annotation a : pa) {
/*  55 */       if (a.annotationType() == annotation)
/*  56 */         return LocatableAnnotation.create(a, srcPos);
/*     */     }
/*  58 */     return null;
/*     */   }
/*     */   
/*     */   public <A extends Annotation> A getClassAnnotation(Class<A> a, Class clazz, Locatable srcPos) {
/*  62 */     return LocatableAnnotation.create(clazz.getAnnotation(a), srcPos);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  69 */   private final Map<Class<? extends Annotation>, Map<Package, Annotation>> packageCache = new HashMap();
/*     */   
/*     */   public <A extends Annotation> A getPackageAnnotation(Class<A> a, Class clazz, Locatable srcPos)
/*     */   {
/*  73 */     Package p = clazz.getPackage();
/*  74 */     if (p == null) { return null;
/*     */     }
/*  76 */     Map<Package, Annotation> cache = (Map)this.packageCache.get(a);
/*  77 */     if (cache == null) {
/*  78 */       cache = new HashMap();
/*  79 */       this.packageCache.put(a, cache);
/*     */     }
/*     */     
/*  82 */     if (cache.containsKey(p)) {
/*  83 */       return (Annotation)cache.get(p);
/*     */     }
/*  85 */     A ann = LocatableAnnotation.create(p.getAnnotation(a), srcPos);
/*  86 */     cache.put(p, ann);
/*  87 */     return ann;
/*     */   }
/*     */   
/*     */   public Class getClassValue(Annotation a, String name)
/*     */   {
/*     */     try {
/*  93 */       return (Class)a.annotationType().getMethod(name, new Class[0]).invoke(a, new Object[0]);
/*     */     }
/*     */     catch (IllegalAccessException e) {
/*  96 */       throw new IllegalAccessError(e.getMessage());
/*     */     }
/*     */     catch (InvocationTargetException e) {
/*  99 */       throw new InternalError(e.getMessage());
/*     */     } catch (NoSuchMethodException e) {
/* 101 */       throw new NoSuchMethodError(e.getMessage());
/*     */     }
/*     */   }
/*     */   
/*     */   protected String fullName(Method m) {
/* 106 */     return m.getDeclaringClass().getName() + '#' + m.getName();
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\model\annotation\RuntimeInlineAnnotationReader.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */