/*     */ package com.sun.xml.bind.v2.runtime;
/*     */ 
/*     */ import com.sun.xml.bind.v2.ClassFactory;
/*     */ import java.util.HashMap;
/*     */ import javax.xml.bind.ValidationEventHandler;
/*     */ import javax.xml.bind.ValidationEventLocator;
/*     */ import javax.xml.bind.annotation.adapters.XmlAdapter;
/*     */ import javax.xml.bind.helpers.ValidationEventImpl;
/*     */ import org.xml.sax.ErrorHandler;
/*     */ import org.xml.sax.SAXException;
/*     */ import org.xml.sax.SAXParseException;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public abstract class Coordinator
/*     */   implements ErrorHandler, ValidationEventHandler
/*     */ {
/*  42 */   private final HashMap<Class<? extends XmlAdapter>, XmlAdapter> adapters = new HashMap();
/*     */   private Coordinator old;
/*     */   private Coordinator[] table;
/*     */   public Exception guyWhoSetTheTableToNull;
/*     */   
/*  47 */   public final XmlAdapter putAdapter(Class<? extends XmlAdapter> c, XmlAdapter a) { if (a == null) {
/*  48 */       return (XmlAdapter)this.adapters.remove(c);
/*     */     }
/*  50 */     return (XmlAdapter)this.adapters.put(c, a);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public final <T extends XmlAdapter> T getAdapter(Class<T> key)
/*     */   {
/*  60 */     T v = (XmlAdapter)key.cast(this.adapters.get(key));
/*  61 */     if (v == null) {
/*  62 */       v = (XmlAdapter)ClassFactory.create(key);
/*  63 */       putAdapter(key, v);
/*     */     }
/*  65 */     return v;
/*     */   }
/*     */   
/*     */   public <T extends XmlAdapter> boolean containsAdapter(Class<T> type) {
/*  69 */     return this.adapters.containsKey(type);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected final void setThreadAffinity()
/*     */   {
/*  95 */     this.table = ((Coordinator[])activeTable.get());
/*  96 */     assert (this.table != null);
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   protected final void resetThreadAffinity()
/*     */   {
/* 104 */     this.guyWhoSetTheTableToNull = new Exception();
/* 105 */     this.table = null;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   protected final void pushCoordinator()
/*     */   {
/* 112 */     this.old = this.table[0];
/* 113 */     this.table[0] = this;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   protected final void popCoordinator()
/*     */   {
/* 120 */     assert (this.table[0] == this);
/* 121 */     this.table[0] = this.old;
/* 122 */     this.old = null;
/*     */   }
/*     */   
/*     */   public static Coordinator _getInstance() {
/* 126 */     return ((Coordinator[])activeTable.get())[0];
/*     */   }
/*     */   
/*     */ 
/* 130 */   private static final ThreadLocal<Coordinator[]> activeTable = new ThreadLocal() {
/*     */     public Coordinator[] initialValue() {
/* 132 */       return new Coordinator[1];
/*     */     }
/*     */   };
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected abstract ValidationEventLocator getLocation();
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   public final void error(SAXParseException exception)
/*     */     throws SAXException
/*     */   {
/* 148 */     propagateEvent(1, exception);
/*     */   }
/*     */   
/*     */   public final void warning(SAXParseException exception) throws SAXException {
/* 152 */     propagateEvent(0, exception);
/*     */   }
/*     */   
/*     */   public final void fatalError(SAXParseException exception) throws SAXException {
/* 156 */     propagateEvent(2, exception);
/*     */   }
/*     */   
/*     */   private void propagateEvent(int severity, SAXParseException saxException)
/*     */     throws SAXException
/*     */   {
/* 162 */     ValidationEventImpl ve = new ValidationEventImpl(severity, saxException.getMessage(), getLocation());
/*     */     
/*     */ 
/* 165 */     Exception e = saxException.getException();
/* 166 */     if (e != null) {
/* 167 */       ve.setLinkedException(e);
/*     */     } else {
/* 169 */       ve.setLinkedException(saxException);
/*     */     }
/*     */     
/*     */ 
/*     */ 
/* 174 */     boolean result = handleEvent(ve);
/* 175 */     if (!result)
/*     */     {
/*     */ 
/* 178 */       throw saxException;
/*     */     }
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\Coordinator.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */