/*    */ package com.sun.xml.bind.v2.runtime.property;
/*    */ 
/*    */ import com.sun.xml.bind.api.AccessorException;
/*    */ import com.sun.xml.bind.v2.model.core.PropertyKind;
/*    */ import com.sun.xml.bind.v2.model.runtime.RuntimeElementPropertyInfo;
/*    */ import com.sun.xml.bind.v2.model.runtime.RuntimeTypeRef;
/*    */ import com.sun.xml.bind.v2.runtime.JAXBContextImpl;
/*    */ import com.sun.xml.bind.v2.runtime.Name;
/*    */ import com.sun.xml.bind.v2.runtime.NameBuilder;
/*    */ import com.sun.xml.bind.v2.runtime.XMLSerializer;
/*    */ import com.sun.xml.bind.v2.runtime.reflect.Accessor;
/*    */ import com.sun.xml.bind.v2.runtime.reflect.TransducedAccessor;
/*    */ import com.sun.xml.bind.v2.runtime.unmarshaller.ChildLoader;
/*    */ import com.sun.xml.bind.v2.runtime.unmarshaller.DefaultValueLoaderDecorator;
/*    */ import com.sun.xml.bind.v2.runtime.unmarshaller.LeafPropertyLoader;
/*    */ import com.sun.xml.bind.v2.runtime.unmarshaller.Loader;
/*    */ import com.sun.xml.bind.v2.runtime.unmarshaller.XsiNilLoader.Single;
/*    */ import com.sun.xml.bind.v2.util.QNameMap;
/*    */ import java.io.IOException;
/*    */ import java.util.List;
/*    */ import javax.xml.stream.XMLStreamException;
/*    */ import org.xml.sax.SAXException;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ final class SingleElementLeafProperty<BeanT>
/*    */   extends PropertyImpl<BeanT>
/*    */ {
/*    */   private final Name tagName;
/*    */   private final boolean nillable;
/*    */   private final Accessor acc;
/*    */   private final String defaultValue;
/*    */   private final TransducedAccessor<BeanT> xacc;
/*    */   
/*    */   public SingleElementLeafProperty(JAXBContextImpl context, RuntimeElementPropertyInfo prop)
/*    */   {
/* 39 */     super(context, prop);
/* 40 */     RuntimeTypeRef ref = (RuntimeTypeRef)prop.getTypes().get(0);
/* 41 */     this.tagName = context.nameBuilder.createElementName(ref.getTagName());
/* 42 */     assert (this.tagName != null);
/* 43 */     this.nillable = ref.isNillable();
/* 44 */     this.defaultValue = ref.getDefaultValue();
/* 45 */     this.acc = prop.getAccessor().optimize();
/*    */     
/* 47 */     this.xacc = TransducedAccessor.get(ref);
/* 48 */     assert (this.xacc != null);
/*    */   }
/*    */   
/*    */   public void reset(BeanT o) throws AccessorException {
/* 52 */     this.acc.set(o, null);
/*    */   }
/*    */   
/*    */   public String getIdValue(BeanT bean) throws AccessorException, SAXException {
/* 56 */     return this.xacc.print(bean).toString();
/*    */   }
/*    */   
/*    */   public void serializeBody(BeanT o, XMLSerializer w, Object outerPeer) throws SAXException, AccessorException, IOException, XMLStreamException {
/* 60 */     boolean hasValue = this.xacc.hasValue(o);
/* 61 */     if (hasValue) {
/* 62 */       this.xacc.writeLeafElement(w, this.tagName, o, this.fieldName);
/*    */     }
/* 64 */     else if (this.nillable) {
/* 65 */       w.startElement(this.tagName, null);
/* 66 */       w.writeXsiNilTrue();
/* 67 */       w.endElement();
/*    */     }
/*    */   }
/*    */   
/*    */   public void buildChildElementUnmarshallers(UnmarshallerChain chain, QNameMap<ChildLoader> handlers) {
/* 72 */     Loader l = new LeafPropertyLoader(this.xacc);
/* 73 */     if (this.defaultValue != null)
/* 74 */       l = new DefaultValueLoaderDecorator(l, this.defaultValue);
/* 75 */     if (this.nillable)
/* 76 */       l = new XsiNilLoader.Single(l, this.acc);
/* 77 */     handlers.put(this.tagName, new ChildLoader(l, null));
/*    */   }
/*    */   
/*    */   public PropertyKind getKind()
/*    */   {
/* 82 */     return PropertyKind.ELEMENT;
/*    */   }
/*    */   
/*    */   public Accessor getElementPropertyAccessor(String nsUri, String localName)
/*    */   {
/* 87 */     if (this.tagName.equals(nsUri, localName)) {
/* 88 */       return this.acc;
/*    */     }
/* 90 */     return null;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\target\myautosupport\WEB-INF\lib\jaxb-impl-2.0.3.jar!\com\sun\xml\bind\v2\runtime\property\SingleElementLeafProperty.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */