/*    */ package com.google.code.yanf4j.core.impl;
/*    */ 
/*    */ import com.google.code.yanf4j.core.Dispatcher;
/*    */ import com.google.code.yanf4j.util.WorkerThreadFactory;
/*    */ import java.util.concurrent.ArrayBlockingQueue;
/*    */ import java.util.concurrent.RejectedExecutionHandler;
/*    */ import java.util.concurrent.ThreadPoolExecutor;
/*    */ import java.util.concurrent.ThreadPoolExecutor.AbortPolicy;
/*    */ import java.util.concurrent.TimeUnit;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class PoolDispatcher
/*    */   implements Dispatcher
/*    */ {
/* 43 */   public static int POOL_QUEUE_SIZE_FACTOR = 1000;
/* 44 */   public static float MAX_POOL_SIZE_FACTOR = 1.25F;
/*    */   private ThreadPoolExecutor threadPool;
/*    */   
/*    */   public PoolDispatcher(int poolSize) {
/* 48 */     this(poolSize, 60L, TimeUnit.SECONDS, new ThreadPoolExecutor.AbortPolicy(), "pool-dispatcher");
/*    */   }
/*    */   
/*    */ 
/*    */   public PoolDispatcher(int poolSize, long keepAliveTime, TimeUnit unit, RejectedExecutionHandler rejectedExecutionHandler, String prefix)
/*    */   {
/* 54 */     this.threadPool = new ThreadPoolExecutor(poolSize, (int)(MAX_POOL_SIZE_FACTOR * poolSize), keepAliveTime, unit, new ArrayBlockingQueue(poolSize * POOL_QUEUE_SIZE_FACTOR), new WorkerThreadFactory(prefix));
/*    */     
/*    */ 
/*    */ 
/*    */ 
/* 59 */     this.threadPool.setRejectedExecutionHandler(rejectedExecutionHandler);
/*    */   }
/*    */   
/*    */   public final void dispatch(Runnable r) {
/* 63 */     if (!this.threadPool.isShutdown()) {
/* 64 */       this.threadPool.execute(r);
/*    */     }
/*    */   }
/*    */   
/*    */   public void stop() {
/* 69 */     this.threadPool.shutdown();
/*    */     try {
/* 71 */       this.threadPool.awaitTermination(1000L, TimeUnit.MILLISECONDS);
/*    */     } catch (InterruptedException e) {
/* 73 */       Thread.currentThread().interrupt();
/*    */     }
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\google\code\yanf4j\core\impl\PoolDispatcher.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */