/*    */ package com.google.code.yanf4j.util;
/*    */ 
/*    */ import java.util.concurrent.ThreadFactory;
/*    */ import java.util.concurrent.atomic.AtomicInteger;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class WorkerThreadFactory
/*    */   implements ThreadFactory
/*    */ {
/* 35 */   private static final AtomicInteger poolNumber = new AtomicInteger(1);
/*    */   private final ThreadGroup group;
/* 37 */   private final AtomicInteger threadNumber = new AtomicInteger(1);
/*    */   private final String namePrefix;
/*    */   
/*    */   public WorkerThreadFactory(ThreadGroup group, String prefix) {
/* 41 */     if (group == null) {
/* 42 */       SecurityManager s = System.getSecurityManager();
/* 43 */       this.group = (s != null ? s.getThreadGroup() : Thread.currentThread().getThreadGroup());
/*    */     }
/*    */     else {
/* 46 */       this.group = group;
/*    */     }
/* 48 */     if (prefix == null) {
/* 49 */       this.namePrefix = ("pool-" + poolNumber.getAndIncrement() + "-thread-");
/*    */     }
/*    */     else {
/* 52 */       this.namePrefix = (prefix + "-" + poolNumber.getAndIncrement() + "-thread-");
/*    */     }
/*    */   }
/*    */   
/*    */   public WorkerThreadFactory(String prefix)
/*    */   {
/* 58 */     this(null, prefix);
/*    */   }
/*    */   
/*    */   public WorkerThreadFactory() {
/* 62 */     this(null, null);
/*    */   }
/*    */   
/*    */   public Thread newThread(Runnable r) {
/* 66 */     Thread t = new Thread(this.group, r, this.namePrefix + this.threadNumber.getAndIncrement(), 0L);
/*    */     
/* 68 */     if (t.isDaemon()) {
/* 69 */       t.setDaemon(false);
/*    */     }
/* 71 */     if (t.getPriority() != 5) {
/* 72 */       t.setPriority(5);
/*    */     }
/* 74 */     return t;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\google\code\yanf4j\util\WorkerThreadFactory.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */