/*    */ package com.netapp.asup.cache.LRU;
/*    */ 
/*    */ import com.googlecode.concurrentlinkedhashmap.Weigher;
/*    */ import com.googlecode.concurrentlinkedhashmap.Weighers;
/*    */ import org.github.jamm.MemoryMeter;
/*    */ 
/*    */ 
/*    */ public class WeigherFactory
/*    */ {
/* 10 */   private static final WeigherFactory INSTANCE = new WeigherFactory();
/*    */   
/*    */ 
/*    */ 
/*    */ 
/*    */   public static WeigherFactory getInstance()
/*    */   {
/* 17 */     return INSTANCE;
/*    */   }
/*    */   
/*    */   public Weigher<?> getWeigher(WeightType type)
/*    */   {
/* 22 */     Weigher<?> memoryUsageWeigher = null;
/* 23 */     switch (type)
/*    */     {
/*    */ 
/*    */     case SIZE: 
/* 27 */       memoryUsageWeigher = getSizeBasedWeigher();
/* 28 */       break;
/*    */     
/*    */ 
/*    */     case ENTRY: 
/* 32 */       memoryUsageWeigher = Weighers.singleton();
/*    */     }
/*    */     
/*    */     
/* 36 */     return memoryUsageWeigher;
/*    */   }
/*    */   
/*    */   private <V> Weigher<?> getSizeBasedWeigher() {
/* 40 */     Weigher<?> memoryUsageWeigher = new Weigher() {
/* 41 */       final MemoryMeter meter = new MemoryMeter();
/*    */       
/*    */ 
/*    */ 
/*    */       public int weightOf(V value)
/*    */       {
/* 47 */         long bytes = this.meter.measureDeep(value);
/* 48 */         return (int)Math.min(bytes, 2147483647L);
/*    */       }
/* 50 */     };
/* 51 */     return memoryUsageWeigher;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\cache\LRU\WeigherFactory.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */