package com.netapp.asup.client.arma;

import com.netapp.asup.client.arma.data.ARMAObjectInstance;
import com.netapp.asup.client.arma.data.ARMAObjectInstanceIterator;
import com.netapp.asup.data.function.RegisteredFunction;
import com.netapp.asup.exception.ARMAException;
import java.util.Collection;
import java.util.Map;
import org.apache.avro.generic.GenericRecord;
import org.apache.avro.util.Utf8;

public abstract interface ARMAObject
  extends ARMAViewOnlyObject
{
  public abstract ARMAObject getRoot();
  
  public abstract Collection<ARMAObject> getParents();
  
  public abstract ARMAObject getParent(String paramString);
  
  public abstract Collection<ARMAObject> getChilds();
  
  public abstract ARMAObject getChild(String paramString);
  
  public abstract Collection<String> getParentNames();
  
  public abstract Collection<String> getChildNames();
  
  public abstract Collection<ARMAObject> getAll();
  
  public abstract ARMAObject getAll(String paramString);
  
  public abstract String getObjectName();
  
  public abstract String getKeyAttribute();
  
  public abstract String getVersion();
  
  public abstract ARMAFilter getFilter();
  
  public abstract Collection<String> getDataAttributes()
    throws ARMAException;
  
  public abstract ARMAObjectInstanceIterator getInstances()
    throws ARMAException;
  
  public abstract void getData(String... paramVarArgs)
    throws ARMAException;
  
  public abstract ARMAObjectInstance getInstance(String paramString1, String paramString2)
    throws ARMAException;
  
  public abstract ARMAViewOnlyObject getViewOnlyARMAObject();
  
  /**
   * @deprecated
   */
  public abstract ARMAObject jumpToPath(String... paramVarArgs)
    throws ARMAException;
  
  public abstract ARMAObject jumpToNode(String paramString)
    throws ARMAException;
  
  public abstract boolean isOptionsAvailable();
  
  public abstract boolean fetchOptions();
  
  public abstract void addObjectToRequest();
  
  public abstract String getSessionId();
  
  public abstract boolean isNodeAvailable(String paramString);
  
  public abstract <I, O> void addFunction(String paramString, RegisteredFunction<I, O> paramRegisteredFunction, I paramI)
    throws ARMAException;
  
  public abstract void addGenericFunction(String paramString, RegisteredFunction<GenericRecord, GenericRecord> paramRegisteredFunction, GenericRecord paramGenericRecord)
    throws ARMAException;
  
  public abstract <I, O> RegisteredFunction<I, O> getRegisteredFunction(String paramString)
    throws ARMAException;
  
  public abstract RegisteredFunction<GenericRecord, GenericRecord> getGenericIORegisteredFunction(String paramString)
    throws ARMAException;
  
  public abstract <I, O> Map<Utf8, O> executeFunction(String paramString, RegisteredFunction<I, O> paramRegisteredFunction, I paramI)
    throws ARMAException;
  
  public abstract void retrieveCounterData(int paramInt, String... paramVarArgs);
  
  public abstract void retrieveEventData(int paramInt, String... paramVarArgs);
  
  public abstract void retrieveEventData(String paramString, int paramInt, String... paramVarArgs);
  
  public abstract void retrieveEventData(int paramInt, boolean paramBoolean, String... paramVarArgs);
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\client\arma\ARMAObject.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */