/*    */ package com.netapp.asup.data.function.sort;
/*    */ 
/*    */ import com.netapp.asup.client.arma.data.ARMAObjectInstance;
/*    */ import com.netapp.asup.data.function.FunctionAttribute;
/*    */ import com.netapp.asup.exception.ARMAException;
/*    */ import java.util.Comparator;
/*    */ import java.util.List;
/*    */ 
/*    */ public class FieldComparator implements Comparator<ARMAObjectInstance>
/*    */ {
/*    */   private SortType sortType;
/*    */   private List<FunctionAttribute> funcAtts;
/*    */   
/*    */   public FieldComparator(SortType sortType, List<FunctionAttribute> funcAtts)
/*    */   {
/* 16 */     this.sortType = sortType;
/* 17 */     this.funcAtts = funcAtts;
/*    */   }
/*    */   
/*    */ 
/*    */   public int compare(ARMAObjectInstance o1, ARMAObjectInstance o2)
/*    */   {
/* 23 */     int result = 0;
/*    */     
/*    */ 
/*    */     try
/*    */     {
/* 28 */       for (FunctionAttribute funcAttr : this.funcAtts)
/*    */       {
/* 30 */         Class<?> attrType = funcAttr.getAttrType();
/*    */         
/* 32 */         String attrName = funcAttr.getAttrName();
/*    */         
/* 34 */         String allAttribute1 = o1.getAllAttribute(attrName);
/* 35 */         String allAttribute2 = o2.getAllAttribute(attrName);
/*    */         
/* 37 */         result = Comparators.compare(attrName, allAttribute1, allAttribute2, attrType, this.sortType);
/*    */         
/* 39 */         if (result != 0)
/*    */           break;
/*    */       }
/*    */     } catch (ARMAException e) {
/* 43 */       throw new IllegalArgumentException("Comparison function failure:", e);
/*    */     }
/*    */     
/* 46 */     return result;
/*    */   }
/*    */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\com\netapp\asup\data\function\sort\FieldComparator.class
 * Java compiler version: 6 (50.0)
 * JD-Core Version:       0.7.1
 */