/*     */ package org.codehaus.janino;
/*     */ 
/*     */ import java.util.Arrays;
/*     */ import java.util.Iterator;
/*     */ import java.util.Map;
/*     */ import java.util.Map.Entry;
/*     */ import java.util.Set;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class ByteArrayClassLoader
/*     */   extends ClassLoader
/*     */ {
/*     */   private static final boolean DEBUG = false;
/*     */   private final Map classes;
/*     */   
/*     */   public ByteArrayClassLoader(Map classes)
/*     */   {
/*  47 */     this.classes = classes;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */   public ByteArrayClassLoader(Map classes, ClassLoader parent)
/*     */   {
/*  54 */     super(parent);
/*  55 */     this.classes = classes;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   protected Class findClass(String name)
/*     */     throws ClassNotFoundException
/*     */   {
/*  66 */     byte[] data = (byte[])this.classes.get(name);
/*  67 */     if (data == null) { throw new ClassNotFoundException(name);
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  83 */     return super.defineClass(name, data, 0, data.length, getClass().getProtectionDomain());
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */   public boolean equals(Object o)
/*     */   {
/* 101 */     if (!(o instanceof ByteArrayClassLoader)) return false;
/* 102 */     if (this == o) return true;
/* 103 */     ByteArrayClassLoader that = (ByteArrayClassLoader)o;
/*     */     
/*     */ 
/* 106 */     ClassLoader parentOfThis = getParent();
/* 107 */     ClassLoader parentOfThat = that.getParent();
/* 108 */     if (parentOfThis == null ? parentOfThat != null : !parentOfThis.equals(parentOfThat)) { return false;
/*     */     }
/*     */     
/* 111 */     if (this.classes.size() != that.classes.size()) return false;
/* 112 */     for (Iterator it = this.classes.entrySet().iterator(); it.hasNext();) {
/* 113 */       Map.Entry me = (Map.Entry)it.next();
/* 114 */       byte[] ba = (byte[])that.classes.get(me.getKey());
/* 115 */       if (ba == null) return false;
/* 116 */       if (!Arrays.equals((byte[])me.getValue(), ba)) return false;
/*     */     }
/* 118 */     return true;
/*     */   }
/*     */   
/* 121 */   public int hashCode() { int hc = getParent().hashCode();
/*     */     
/* 123 */     for (Iterator it = this.classes.entrySet().iterator(); it.hasNext();) {
/* 124 */       Map.Entry me = (Map.Entry)it.next();
/* 125 */       hc ^= me.getKey().hashCode();
/* 126 */       byte[] ba = (byte[])me.getValue();
/* 127 */       for (int i = 0; i < ba.length; i++) {
/* 128 */         hc = 31 * hc ^ ba[i];
/*     */       }
/*     */     }
/* 131 */     return hc;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\janino\ByteArrayClassLoader.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       0.7.1
 */