/*     */ package org.codehaus.janino.util;
/*     */ 
/*     */ import java.io.ByteArrayOutputStream;
/*     */ import java.io.IOException;
/*     */ import java.io.InputStream;
/*     */ import org.codehaus.janino.JaninoRuntimeException;
/*     */ import org.codehaus.janino.util.resource.Resource;
/*     */ import org.codehaus.janino.util.resource.ResourceFinder;
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ public class ResourceFinderClassLoader
/*     */   extends ClassLoader
/*     */ {
/*     */   private static final boolean DEBUG = false;
/*     */   private final ResourceFinder resourceFinder;
/*     */   
/*     */   public ResourceFinderClassLoader(ResourceFinder resourceFinder, ClassLoader parent)
/*     */   {
/*  50 */     super(parent);
/*  51 */     this.resourceFinder = resourceFinder;
/*     */   }
/*     */   
/*     */   public ResourceFinder getResourceFinder() {
/*  55 */     return this.resourceFinder;
/*     */   }
/*     */   
/*     */ 
/*     */ 
/*     */ 
/*     */   protected Class findClass(String className)
/*     */     throws ClassNotFoundException
/*     */   {
/*  64 */     Resource classFileResource = this.resourceFinder.findResource(ClassFile.getClassFileResourceName(className));
/*  65 */     if (classFileResource == null) { throw new ClassNotFoundException(className);
/*     */     }
/*     */     InputStream is;
/*     */     try
/*     */     {
/*  70 */       is = classFileResource.open();
/*     */     } catch (IOException ex) {
/*  72 */       throw new JaninoRuntimeException("Opening class file resource \"" + classFileResource.getFileName() + "\": " + ex.getMessage());
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*  81 */     ByteArrayOutputStream baos = new ByteArrayOutputStream();
/*     */     try {
/*  83 */       byte[] buffer = new byte['က'];
/*     */       for (;;) {
/*  85 */         int bytesRead = is.read(buffer);
/*  86 */         if (bytesRead == -1) break;
/*  87 */         baos.write(buffer, 0, bytesRead);
/*     */       }
/*     */       
/*     */       try
/*     */       {
/*  92 */         is.close();
/*     */       } catch (IOException ex) {}
/*  94 */       ba = baos.toByteArray();
/*     */     }
/*     */     catch (IOException ex)
/*     */     {
/*  90 */       throw new ClassNotFoundException("Reading class file from \"" + classFileResource + "\"", ex);
/*     */     } finally {
/*  92 */       try { is.close();
/*     */       }
/*     */       catch (IOException ex) {}
/*     */     }
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */     byte[] ba;
/*     */     
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 108 */     Class clazz = super.defineClass(null, ba, 0, ba.length);
/*     */     
/* 110 */     if (!clazz.getName().equals(className))
/*     */     {
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/*     */ 
/* 117 */       throw new ClassNotFoundException(className);
/*     */     }
/*     */     
/* 120 */     return clazz;
/*     */   }
/*     */ }


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\org\codehaus\janino\util\ResourceFinderClassLoader.class
 * Java compiler version: 1 (45.3)
 * JD-Core Version:       0.7.1
 */