/*    */ package org.hibernate.annotations.common.reflection.java;
/*    */ 
/*    */ 
/*    */ 
/*    */ abstract class Pair<T, U>
/*    */ {
/*    */   private final T o1;
/*    */   
/*    */ 
/*    */   private final U o2;
/*    */   
/*    */   private final int hashCode;
/*    */   
/*    */ 
/*    */   Pair(T o1, U o2)
/*    */   {
/* 17 */     this.o1 = o1;
/* 18 */     this.o2 = o2;
/* 19 */     this.hashCode = doHashCode();
/*    */   }
/*    */   
/*    */   public boolean equals(Object obj)
/*    */   {
/* 24 */     if (!(obj instanceof Pair)) {
/* 25 */       return false;
/*    */     }
/* 27 */     Pair other = (Pair)obj;
/* 28 */     return (!differentHashCode(other)) && (safeEquals(this.o1, other.o1)) && (safeEquals(this.o2, other.o2));
/*    */   }
/*    */   
/*    */   private boolean differentHashCode(Pair other) {
/* 32 */     return this.hashCode != other.hashCode;
/*    */   }
/*    */   
/*    */ 
/*    */   public int hashCode()
/*    */   {
/* 38 */     return this.hashCode;
/*    */   }
/*    */   
/*    */   private int doHashCode() {
/* 42 */     return safeHashCode(this.o1) ^ safeHashCode(this.o2);
/*    */   }
/*    */   
/*    */   private int safeHashCode(Object o) {
/* 46 */     if (o == null) {
/* 47 */       return 0;
/*    */     }
/* 49 */     return o.hashCode();
/*    */   }
/*    */   
/*    */   private boolean safeEquals(Object obj1, Object obj2) {
/* 53 */     if (obj1 == null) {
/* 54 */       return obj2 == null;
/*    */     }
/* 56 */     return obj1.equals(obj2);
/*    */   }
/*    */ }


/* Location:              /Users/anandkum/Downloads/hibernate-commons-annotations-3.0.0.ga.jar!/org/hibernate/annotations/common/reflection/java/Pair.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */