/*    */ package org.hibernate.annotations.common.reflection.java.generics;
/*    */ 
/*    */ import java.lang.reflect.Type;
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ 
/*    */ public class CompoundTypeEnvironment
/*    */   implements TypeEnvironment
/*    */ {
/*    */   private final TypeEnvironment f;
/*    */   private final TypeEnvironment g;
/*    */   private final int hashCode;
/*    */   
/*    */   public static TypeEnvironment create(TypeEnvironment f, TypeEnvironment g)
/*    */   {
/* 20 */     if (g == IdentityTypeEnvironment.INSTANCE)
/* 21 */       return f;
/* 22 */     if (f == IdentityTypeEnvironment.INSTANCE)
/* 23 */       return g;
/* 24 */     return new CompoundTypeEnvironment(f, g);
/*    */   }
/*    */   
/*    */   private CompoundTypeEnvironment(TypeEnvironment f, TypeEnvironment g) {
/* 28 */     this.f = f;
/* 29 */     this.g = g;
/* 30 */     this.hashCode = doHashCode();
/*    */   }
/*    */   
/*    */   public Type bind(Type type) {
/* 34 */     return this.f.bind(this.g.bind(type));
/*    */   }
/*    */   
/*    */   public boolean equals(Object o) {
/* 38 */     if (this == o) return true;
/* 39 */     if (!(o instanceof CompoundTypeEnvironment)) { return false;
/*    */     }
/* 41 */     CompoundTypeEnvironment that = (CompoundTypeEnvironment)o;
/*    */     
/* 43 */     if (differentHashCode(that)) { return false;
/*    */     }
/* 45 */     if (!this.f.equals(that.f)) return false;
/* 46 */     return this.g.equals(that.g);
/*    */   }
/*    */   
/*    */   private boolean differentHashCode(CompoundTypeEnvironment that)
/*    */   {
/* 51 */     return this.hashCode != that.hashCode;
/*    */   }
/*    */   
/*    */   private int doHashCode()
/*    */   {
/* 56 */     int result = this.f.hashCode();
/* 57 */     result = 29 * result + this.g.hashCode();
/* 58 */     return result;
/*    */   }
/*    */   
/*    */   public int hashCode()
/*    */   {
/* 63 */     return this.hashCode;
/*    */   }
/*    */   
/*    */   public String toString()
/*    */   {
/* 68 */     return this.f.toString() + "(" + this.g.toString() + ")";
/*    */   }
/*    */ }


/* Location:              /Users/anandkum/Downloads/hibernate-commons-annotations-3.0.0.ga.jar!/org/hibernate/annotations/common/reflection/java/generics/CompoundTypeEnvironment.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */