package prefuse.action.layout;

import java.awt.geom.Point2D;
import java.awt.geom.Point2D.Double;
import java.awt.geom.Rectangle2D;
import java.util.Iterator;
import prefuse.Visualization;
import prefuse.visual.NodeItem;
import prefuse.visual.VisualItem;
import prefuse.visual.expression.StartVisiblePredicate;

public class CollapsedSubtreeLayout
  extends Layout
{
  private int m_orientation;
  private Point2D m_point = new Point2D.Double();
  
  public CollapsedSubtreeLayout(String paramString)
  {
    this(paramString, 4);
  }
  
  public CollapsedSubtreeLayout(String paramString, int paramInt)
  {
    super(paramString);
    this.m_orientation = paramInt;
  }
  
  public int getOrientation()
  {
    return this.m_orientation;
  }
  
  public void setOrientation(int paramInt)
  {
    if ((paramInt < 0) || (paramInt >= 5)) {
      throw new IllegalArgumentException("Unrecognized orientation value: " + paramInt);
    }
    this.m_orientation = paramInt;
  }
  
  public void run(double paramDouble)
  {
    Iterator localIterator = this.m_vis.visibleItems(this.m_group);
    VisualItem localVisualItem;
    NodeItem localNodeItem;
    Point2D localPoint2D;
    while (localIterator.hasNext())
    {
      localVisualItem = (VisualItem)localIterator.next();
      if (((localVisualItem instanceof NodeItem)) && (!localVisualItem.isStartVisible()))
      {
        localNodeItem = (NodeItem)localVisualItem;
        localPoint2D = getPoint(localNodeItem, true);
        localNodeItem.setStartX(localPoint2D.getX());
        localNodeItem.setStartY(localPoint2D.getY());
      }
    }
    localIterator = this.m_vis.items(this.m_group, StartVisiblePredicate.TRUE);
    while (localIterator.hasNext())
    {
      localVisualItem = (VisualItem)localIterator.next();
      if (((localVisualItem instanceof NodeItem)) && (!localVisualItem.isEndVisible()))
      {
        localNodeItem = (NodeItem)localVisualItem;
        localPoint2D = getPoint(localNodeItem, false);
        localNodeItem.setStartX(localNodeItem.getEndX());
        localNodeItem.setStartY(localNodeItem.getEndY());
        localNodeItem.setEndX(localPoint2D.getX());
        localNodeItem.setEndY(localPoint2D.getY());
      }
    }
  }
  
  private Point2D getPoint(NodeItem paramNodeItem, boolean paramBoolean)
  {
    NodeItem localNodeItem = (NodeItem)paramNodeItem.getParent();
    if (paramBoolean) {
      while ((localNodeItem != null) && (!localNodeItem.isStartVisible())) {
        localNodeItem = (NodeItem)localNodeItem.getParent();
      }
    }
    while ((localNodeItem != null) && (!localNodeItem.isEndVisible())) {
      localNodeItem = (NodeItem)localNodeItem.getParent();
    }
    if (localNodeItem == null)
    {
      this.m_point.setLocation(paramNodeItem.getX(), paramNodeItem.getY());
      return this.m_point;
    }
    double d1 = paramBoolean ? localNodeItem.getStartX() : localNodeItem.getEndX();
    double d2 = paramBoolean ? localNodeItem.getStartY() : localNodeItem.getEndY();
    Rectangle2D localRectangle2D = localNodeItem.getBounds();
    switch (this.m_orientation)
    {
    case 0: 
      this.m_point.setLocation(d1 + localRectangle2D.getWidth(), d2);
      break;
    case 1: 
      this.m_point.setLocation(d1 - localRectangle2D.getWidth(), d2);
      break;
    case 2: 
      this.m_point.setLocation(d1, d2 + localRectangle2D.getHeight());
      break;
    case 3: 
      this.m_point.setLocation(d1, d2 - localRectangle2D.getHeight());
      break;
    case 4: 
      this.m_point.setLocation(d1, d2);
    }
    return this.m_point;
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\action\layout\CollapsedSubtreeLayout.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */