package prefuse.action.layout.graph;

import prefuse.Visualization;
import prefuse.action.layout.Layout;
import prefuse.data.Graph;
import prefuse.data.Tree;
import prefuse.data.tuple.TupleSet;
import prefuse.visual.NodeItem;

public abstract class TreeLayout
  extends Layout
{
  protected NodeItem m_root;
  
  public TreeLayout() {}
  
  public TreeLayout(String paramString)
  {
    super(paramString);
  }
  
  public void setLayoutRoot(NodeItem paramNodeItem)
  {
    if (!paramNodeItem.isInGroup(this.m_group)) {
      throw new IllegalArgumentException("Input node is not a member of this layout's data group");
    }
    this.m_root = paramNodeItem;
  }
  
  public NodeItem getLayoutRoot()
  {
    if (this.m_root != null) {
      return this.m_root;
    }
    TupleSet localTupleSet = this.m_vis.getGroup(this.m_group);
    if ((localTupleSet instanceof Graph))
    {
      Tree localTree = ((Graph)localTupleSet).getSpanningTree();
      return (NodeItem)localTree.getRoot();
    }
    throw new IllegalStateException("This action's data group doesnot resolve to a Graph instance.");
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\action\layout\graph\TreeLayout.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */