package prefuse.controls;

import java.awt.Cursor;
import java.awt.event.MouseEvent;
import prefuse.Display;
import prefuse.Visualization;
import prefuse.data.tuple.TupleSet;
import prefuse.util.ui.UILib;
import prefuse.visual.VisualItem;

public class FocusControl
  extends ControlAdapter
{
  private String group = Visualization.FOCUS_ITEMS;
  protected String activity;
  protected VisualItem curFocus;
  protected int ccount;
  protected int button = 16;
  
  public FocusControl()
  {
    this(1);
  }
  
  public FocusControl(String paramString)
  {
    this(1);
  }
  
  public FocusControl(int paramInt)
  {
    this.ccount = paramInt;
  }
  
  public FocusControl(String paramString, int paramInt)
  {
    this.ccount = paramInt;
    this.group = paramString;
  }
  
  public FocusControl(int paramInt, String paramString)
  {
    this.ccount = paramInt;
    this.activity = paramString;
  }
  
  public FocusControl(String paramString1, int paramInt, String paramString2)
  {
    this.ccount = paramInt;
    this.activity = paramString2;
    this.group = paramString1;
  }
  
  public void itemEntered(VisualItem paramVisualItem, MouseEvent paramMouseEvent)
  {
    Display localDisplay = (Display)paramMouseEvent.getSource();
    localDisplay.setCursor(Cursor.getPredefinedCursor(12));
    if (this.ccount == 0)
    {
      Visualization localVisualization = paramVisualItem.getVisualization();
      TupleSet localTupleSet = localVisualization.getFocusGroup(this.group);
      localTupleSet.setTuple(paramVisualItem);
      this.curFocus = paramVisualItem;
      runActivity(localVisualization);
    }
  }
  
  public void itemExited(VisualItem paramVisualItem, MouseEvent paramMouseEvent)
  {
    Display localDisplay = (Display)paramMouseEvent.getSource();
    localDisplay.setCursor(Cursor.getDefaultCursor());
    if (this.ccount == 0)
    {
      this.curFocus = null;
      Visualization localVisualization = paramVisualItem.getVisualization();
      TupleSet localTupleSet = localVisualization.getFocusGroup(this.group);
      localTupleSet.removeTuple(paramVisualItem);
      runActivity(localVisualization);
    }
  }
  
  public void itemClicked(VisualItem paramVisualItem, MouseEvent paramMouseEvent)
  {
    if ((UILib.isButtonPressed(paramMouseEvent, this.button)) && (paramMouseEvent.getClickCount() == this.ccount) && (paramVisualItem != this.curFocus))
    {
      Visualization localVisualization = paramVisualItem.getVisualization();
      TupleSet localTupleSet = localVisualization.getFocusGroup(this.group);
      boolean bool = paramMouseEvent.isControlDown();
      if (!bool)
      {
        this.curFocus = paramVisualItem;
        localTupleSet.setTuple(paramVisualItem);
      }
      else if (localTupleSet.containsTuple(paramVisualItem))
      {
        localTupleSet.removeTuple(paramVisualItem);
      }
      else
      {
        localTupleSet.addTuple(paramVisualItem);
      }
      runActivity(localVisualization);
    }
  }
  
  private void runActivity(Visualization paramVisualization)
  {
    if (this.activity != null) {
      paramVisualization.run(this.activity);
    }
  }
}


/* Location:              C:\Perforce\MyAsup\dev\thirdparty\lib\asup-metamodel-client-1.0.jar!\prefuse\controls\FocusControl.class
 * Java compiler version: 5 (49.0)
 * JD-Core Version:       0.7.1
 */